% kriticke zosilnenie P regulatora pre system 3 radu
% v tvare : b0/(s^3+ a2 s^2 + a1 s + a0)
% odpoved: Zrk \le (a1*a2-a0)/b0

s1='\begin{problem}[\split]';
s2='Critical gain of a P controller in closed-loop ';
s3='with controlled system described by transfer function ';

s4='je ';
s5='\score{2}';
if exist('anstype','var')
  s6=' ';
  s9='\shortanswer{';
  s10=' ';
else
  s6='\begin{choice}';
  s9='\gooditem{';
  s10='\end{choice}';
end
s7='\baditem{';
s8='}';
s11='\end{problem}';
s12='no other response is correct';


num=fix(rand(1,1)*10)+1; b0=num(1,1);
den=fix(rand(1,3)*10)+1; 
while (-den(1,2)*den(1,3)+ den(1,1) >0),
  den=fix(rand(1,3)*10)+1; 
end
a2 = den(1,3); a1 = den(1,2); a0 = den(1,1);
zrk = (a1*a2-a0)/b0;
[gs,e]=sprintf('$G_p(s) = \\frac{%.0f}{s^3 %+.0f s^2 %+.0f s %+.0f}$ ',b0,a2,a1,a0);
choices = fix(randn(1,4)*1000+30)/100; 
[ss1,e]=sprintf('%s%s%s',s7,s12,s8);
[ss2,e]=sprintf('%s%.2f%s',s7,choices(2),s8);
[ss3,e]=sprintf('%s%.2f%s',s7,choices(3),s8);
[ss4,e]=sprintf('%s%.2f%s',s7,choices(4),s8);
[ss5,e]=sprintf('%s%.2f%s',s9,zrk,s8);
sss = {ss1,ss2,ss3,ss4,ss5};
i = randperm(5);

fid = fopen('krit1.tex','w');
fprintf(fid,'%s\n%s\n%s\n%s\n%s\n%s\n%s\n',s1,s2,s3,gs,s4,s5,s6);
if exist('anstype','var')
  fprintf(fid,'%s\n',ss5);
else
  fprintf(fid,'%s\n',sss{i(1)},sss{i(2)},sss{i(3)},sss{i(4)},sss{i(5)});
end
fprintf(fid,'%s\n%s\n\n',s10,s11);
fclose(fid);
 
% $$$ choices = fix([1.8 1.9 2.1 2.3]*zrk*1000)/100; 
% $$$ [ss1,e]=sprintf('%s%.2f%s',s7,choices(1),s8);
% $$$ [ss2,e]=sprintf('%s%.2f%s',s7,choices(2),s8);
% $$$ [ss3,e]=sprintf('%s%.2f%s',s7,choices(3),s8);
% $$$ [ss4,e]=sprintf('%s%.2f%s',s7,choices(4),s8);
% $$$ [ss5,e]=sprintf('%s%s%s',s9,s12,s8);
% $$$ s = {ss1,ss2,ss3,ss4,ss5};
% $$$ i = randperm(5);
% $$$ 
% $$$ fid = fopen('krit1n.tex','w');
% $$$ fprintf(fid,'%s\n%s\n%s\n%s\n%s\n%s\n%s\n',s1,s2,s3,gs,s4,s5,s6);
% $$$ fprintf(fid,'%s\n%s\n%s\n%s\n%s\n',s{i(1)},s{i(2)},s{i(3)},s{i(4)},s{i(5)});
% $$$ fprintf(fid,'%s\n%s\n\n',s10,s11);
% $$$ fclose(fid);
 


