% kriticke zosilnenie PI regulatora (P+I/s) pre system 2 radu
% v tvare : b0/(s^2 + a1 s + a0)
% odpoved: a0+ b0 P - b0/a1 I \ge 0

s1='\begin{problem}[\split]';
s2a1='Find the critical value of $P$ for PI'; 
s2b1='Find the critical value of $I$ for PI';
s2='controller with transfer function $G_R(s) = P+I/s$ ';
s2a2='(if $I='; s2b2='(if $P=';
s2e='$)';
s3='in closed-loop with controlled system with transfer function ';

s5='\score{2}';
if exist('anstype','var')
  s6=' ';
  s9='\shortanswer{';
  s10=' ';
else
  s6='\begin{choice}';
  s9='\gooditem{';
  s10='\end{choice}';
end
s7='\baditem{';
s8='}';
s11='\end{problem}';
s12='no other response is correct';


num=fix(rand(1,1)*10)+1; b0=num(1,1);
den=fix(rand(1,2)*10)+1; 
pp = fix(rand(1,1)*10)+1; 
ii = fix(rand(1,1)*10)+1; 
while ( (-den(1,1)-b0*pp>0) | (den(1,1)-b0/den(1,2)*ii>0)  ),
  den=fix(rand(1,2)*10)+1; 
end
a1 = den(1,2); a0 = den(1,1);
ppk = -(a0-b0/a1*ii)/b0;
iik = (a0+b0*pp)*a1/b0;
[gs,e]=sprintf('$G_p(s) = \\frac{%.0f}{s^2 %+.0f s %+.0f}$ ',b0,a1,a0);
choices = fix(rand(1,4)*1000+1)/100; 
[ss1,e]=sprintf('%s%s%s',s7,s12,s8);
[ss2,e]=sprintf('%s%.2f%s',s7,choices(2),s8);
[ss3,e]=sprintf('%s%.2f%s',s7,choices(3),s8);
[ss4,e]=sprintf('%s%.2f%s',s7,choices(4),s8);
[ss5,e]=sprintf('%s%.2f%s',s9,ppk,s8);
s = {ss1,ss2,ss3,ss4,ss5};
i = randperm(5);


choices = fix(rand(1,4)*1000+1)/100; 
[ss1,e]=sprintf('%s%s%s',s7,s12,s8);
[ss2,e]=sprintf('%s%.2f%s',s7,choices(2),s8);
[ss3,e]=sprintf('%s%.2f%s',s7,choices(3),s8);
[ss4,e]=sprintf('%s%.2f%s',s7,choices(4),s8);
[ss5,e]=sprintf('%s%.2f%s',s9,iik,s8);
s = {ss1,ss2,ss3,ss4,ss5};
i = randperm(5);

fid = fopen('krit2ii.tex','w');
fprintf(fid,'%s\n%s\n%s\n%s%.0f%s\n%s\n%s\n%s\n%s\n',s1,s2b1,s2,s2b2,pp,s2e,s3,gs,s5,s6);
if exist('anstype','var')
  fprintf(fid,'%s\n',ss5);
else
  fprintf(fid,'%s\n',s{i(1)},s{i(2)},s{i(3)},s{i(4)},s{i(5)});
end
fprintf(fid,'%s\n%s\n\n',s10,s11);
fclose(fid);
 
