% Step response
% a2 y''(t) +a1 y'(t)+a0 y(t) = b0
% single stable real pole with multiplicity
score=3;
s1='\begin{problem}[\split]';
s2='The step response function of the process described by the differential equation  ';
%y(t)
s3='is';

[p5,e]=sprintf('\\score{%.0f} ',score);
if exist('anstype','var')
  p6=' ';
  p9='\shortanswer{';
  p10=' ';
else
  p6='\begin{choice}';
  p9='\gooditem{';
  p10='\end{choice}';
end
p7='\baditem{';
p8='}';
p11='\end{problem}';
p12='no other response is correct';


num = randperm(5);
b0=num(1); 
den=randperm(10); 
p1 = den(2); p2 = p1; a2 = den(1);
a1 = a2*(p1+p2); a0 = a2*p1*p2;
[gs,e]=sprintf('$%d y''''(t) %+d y''(t) %+d y(t) = %d u(t)$ ',a2,a1,a0,b0);
choi=num(3:5); 

oks = sprintf(' ''%s*D2y+%s*Dy+%s*y = %s'',''Dy(0)=0'',''y(0)=0'' '   ,num2str(a2),num2str(a1), num2str(a0), num2str(b0) );
ok = latex(dsolve(oks));
bad1s = sprintf(' ''%s*D2y+%s*Dy+%s*y = %s'',''Dy(0)=0'',''y(0)=%s'' '   ,num2str(a2),num2str(a1), num2str(a0), num2str(b0), num2str(choi(1)) );
bad1 = latex(dsolve(bad1s));
bad2s = sprintf(' ''%s*D2y+%s*Dy+%s*y = %s'',''Dy(0)=0'',''y(0)=%s'' '   ,num2str(a2),num2str(a1), num2str(a0), num2str(choi(2)), num2str(0) );
bad2 = latex(dsolve(bad2s));
bad3s = sprintf(' ''%s*D2y+%s*Dy+%s*y = %s'',''Dy(0)=0'',''y(0)=%s'' '   ,num2str(a2),num2str(a1), num2str(a0), num2str(choi(3)), num2str(0) );
bad3 = latex(dsolve(bad3s));
[ss1,e]=sprintf('%s%s%s',p7,p12,p8);
[ss2,e]=sprintf('%s$%s$%s',p7,char(bad1),p8);
[ss3,e]=sprintf('%s$%s$%s',p7,char(bad2),p8);
[ss4,e]=sprintf('%s$%s$%s',p7,char(bad3),p8);
[ss5,e]=sprintf('%s$%s$%s',p9,char(ok),p8);
sss = {ss1,ss2,ss3,ss4,ss5};
i = randperm(5);

fid = fopen('pch1.tex','w');
fprintf(fid,'%s\n',s1,s2,gs,s3,p5,p6);
if exist('anstype','var')
  fprintf(fid,'%s\n',ss5);
else
  fprintf(fid,'%s\n',sss{i(1)},sss{i(2)},sss{i(3)},sss{i(4)},sss{i(5)});
end
fprintf(fid,'%s\n%s\n\n',p10,p11);
fclose(fid);
 
